implementation class
Alternatives: Element, MutableObjectArray

end;

implementation instance
Alternatives

void
  checkLL1
{
  int i, j;

  for (i = 0; i < length; i++)
    {
      [self[i] checkLL1];

      for (j = i + 1; j < length; j++)
	{
	  IntegerRangeSet isec
	    = [[self[i] la] intersectionWith [self[j] la]];

	  if (![isec isEmpty])
	    {
	      OutputStream s = [[Parser current_parser] error self];

	      [s print ("overlap in alternatives ", i, " and ", j, ": ")];

	      [[[Parser current_parser]
		 describe s tokens [isec enumerator]] nl];
	    }
	}
    }
}

OutputStream
  compile OutputStream s
{
  if (length == 1)
    return [self[0] compile s];

  boolean first = YES;
  Element epsilon;
  int i;

  for (i = 0; i < length; i++)
    {
      Element sym = self[i];

      if ([[sym first] member EPSILON])
	if (epsilon != nil)
	  [[[Parser error self] print "multiple EPSILON rules"] nl];
	else
	  epsilon = sym;
      else
	{
	  if (first)
	    {
	      [s print indent];
	      first = NO;
	    }
	  else
	    [s print (indent, "else ")];

	  [s print ("if ", [isa condition [[sym la] enumerator]])];
	  [indent add ' '];
	  [s print (indent, "{")];
	  [indent add ' '];

	  [sym compile s];

	  [indent removeElementAt 1];
	  [s print (indent, "}")];
	  [indent removeElementAt 1];
	}
    }

  if (epsilon != nil)
    {
      if (!first)
	[s print (indent, "else")];

      [indent add ' '];
      [s print (indent, "{")];
      [indent add ' '];

      [epsilon compile s];

      [indent removeElementAt 1];
      [s print (indent, "}")];
      [indent removeElementAt 1];
    }
  else
    [s print (indent, "else [self fatalError];")];

  = s;
}

IntegerRangeSet
  computeLA IntegerRangeSet f
{
  if (!follow)
    follow = f;
  else if (run == current_run && [f equal follow])
    return la;
  run = current_run;

  IntegerRangeSet nf = [IntegerRangeSet new];
  if (!la)
    la = [IntegerRangeSet new];

  int i;
  for (i = 0; i < length; i++)
    {
      Element s = self[i];

      [la uniteWith [s computeLA follow]];
      [nf uniteWith [s first]];
    }

  if (first == nil || ![first equal nf])
    changes = YES;

  first = nf;

  = la;
}

<doc> An {Alternatives} should never occur in a flat rule, hence this
    method should not be invoked.  </doc>
OutputStream (s)
  describe-flat-rule OutputStream s
// pre && FALSE
{
  [self shouldNotImplement cmd];
}

Element
  makeFlatRules String lhs_name
{
  NonTerminal nt = (!lhs_name ? [NonTerminal newAnonymous]
		    : [parser nonTerminal lhs_name]);

  int i;
  for (i = 0; i < length; i++)
    [FlatRule for nt expansion [self[i] makeFlatRules nil]];

  = nt;
}

end;
